/// <reference path="lib.d.ts" />
/// <reference path="../../typings/polymer/polymer.d.ts" />
Polymer({
    is: 'path-dialog',
    properties: {
        open: Object,
        onchanged: Object,
        label: {
            type: String,
            value: ""
        },
        path: {
            type: String,
            value: ""
        }
    },
    getDialog: function () {
        return document.getElementById('path-change-dialog');
    },
    onchanged: function (p) {
        console.log("path-dialog: Callback 'onchanged' is ignored: " + p);
    },
    open: function () {
        // Note:
        // 'chooser_opened' is a workaround to avoid calling 'onchanged'
        // callback twice.
        this.chooser_opened = false;
        this.getDialog().open();
    },
    onChooserLaunched: function () {
        this.chooser_opened = true;
        document.getElementById('path-hidden-input').click();
    },
    onFileSpecified: function () {
        // XXX: 'path' doesn't exist in standard File object?
        var path = document.getElementById('path-hidden-input').files[0].path;
        document.getElementById('path-text-area').value = path;
        this.path = path;
        this.onchanged(path);
    },
    setupDialog: function (dialog) {
        var _this = this;
        dialog.addEventListener('iron-overlay-closed', function () {
            var textarea = document.getElementById('path-text-area');
            _this.path = textarea.value;
            if (!_this.chooser_opened) {
                _this.onchanged(_this.path);
            }
        });
    },
    setupToggleButton: function () {
        var toggle = document.getElementById('want-to-choose-dir-button');
        toggle.addEventListener('change', function () {
            var hidden_input = document.getElementById('path-hidden-input');
            if (this.checked) {
                hidden_input.setAttribute('webkitdirectory', '');
                hidden_input.setAttribute('directory', '');
            }
            else {
                hidden_input.removeAttribute('webkitdirectory');
                hidden_input.removeAttribute('directory');
            }
        });
    },
    ready: function () {
        var dialog = this.getDialog();
        this.setupDialog(dialog);
        this.setupToggleButton();
    }
});
