var js_yaml_1 = require('js-yaml');
var path_1 = require('path');
var fs_1 = require('fs');
var app_1 = require('app');
function load() {
    if (this.user_config) {
        return this.user_config;
    }
    var file = path_1.join(app_1.getPath('userData'), 'config.yml');
    var default_config = {
        linter: "mdast-lint",
        file_ext: {
            markdown: ["md", "markdown", "mkd"],
            html: ["html"]
        },
        width: 800,
        height: 600,
        voice: {
            enabled: false,
            source: '../voices/bow.mp3',
        },
        shortcuts: {
            'j': 'PageDown',
            'k': 'PageUp',
            'down': 'PageDown',
            'up': 'PageUp',
            'pagedown': 'PageDown',
            'pageup': 'PageUp',
            'h': 'PageLeft',
            'l': 'PageRight',
            'left': 'PageLeft',
            'right': 'PageRight',
            'i': 'PageTop',
            'm': 'PageBottom',
            'home': 'PageTop',
            'end': 'PageBottom',
            'ctrl+p': 'ChangePath',
            'ctrl+l': 'Lint'
        }
    };
    function mergeConfig(c1, c2) {
        for (var k in c2) {
            var v2 = c2[k];
            if (k in c1) {
                var v1 = c1[k];
                if (typeof (v1) === "object" && typeof (v2) === "object") {
                    mergeConfig(v1, v2);
                }
                continue;
            }
            c1[k] = c2[k];
        }
    }
    try {
        this.user_config = js_yaml_1.load(fs_1.readFileSync(file, { encoding: 'utf8' }));
        mergeConfig(this.user_config, default_config);
    }
    catch (e) {
        console.log('No configuration file is found: ' + file);
        this.user_config = default_config;
    }
    return this.user_config;
}
exports.load = load;
