var emoji_1 = require('../../src/browser/emoji');
context('Emoji', function () {
    return describe('#replaceAll', function () {
        it('does nothing to text including no emoji', function () {
            assert.strictEqual(emoji_1.replaceAll(''), '');
            assert.strictEqual(emoji_1.replaceAll('foo bar'), 'foo bar');
            assert.strictEqual(emoji_1.replaceAll(':bar'), ':bar');
            assert.strictEqual(emoji_1.replaceAll('foo :bar'), 'foo :bar');
        });
        it('does nothing to unknown emoji', function () {
            assert.strictEqual(emoji_1.replaceAll(':boku_no_kangaeta_saikyouno_emoji:'), ':boku_no_kangaeta_saikyouno_emoji:');
            assert.strictEqual(emoji_1.replaceAll('Ah, I do not know :this_emoij:. Do not :replace_this_emoji:.'), 'Ah, I do not know :this_emoij:. Do not :replace_this_emoji:.');
        });
        it('replaces emojis with <img> tag', function () {
            assert.match(emoji_1.replaceAll(':dog:'), /^<img [^>]+><\/img>$/);
            assert.match(emoji_1.replaceAll(':dog: walks with you.'), /^<img [^>]+><\/img> walks with you\.$/);
            assert.match(emoji_1.replaceAll(':dog: walks with :cat:.'), /^<img [^>]+><\/img> walks with <img [^>]+><\/img>\.$/);
            assert.match(emoji_1.replaceAll(':dog: walks with :foo:.'), /^<img [^>]+><\/img> walks with :foo:\.$/);
        });
    });
});
