var linter_1 = require('../../src/browser/linter');
context('Linter', function () {
    describe('constructor', function () {
        it('generates linter object', function () {
            assert.isDefined(linter_1.default);
            assert.isDefined(new linter_1.default('markdownlint', {}));
        });
        it("accepts names 'markdownlint', 'mdast-lint' and 'none'", function () {
            var lint_url_of = function (name) { return (new linter_1.default(name, {})).lint_url; };
            var lint_of = function (name) { return (new linter_1.default(name, {})).lint; };
            assert.ok(lint_url_of('markdownlint'));
            assert.isFunction(lint_of('markdownlint'));
            assert.ok(lint_url_of('mdast-lint'));
            assert.isFunction(lint_of('mdast-lint'));
            assert.notOk(lint_url_of('none'));
            assert.isFunction(lint_of('none'));
            assert.notOk(lint_url_of('unknown_linter_name'));
            assert.isFunction(lint_of('unknown_linter_name'));
        });
    });
    describe('markdownlint', function () {
        var linter = new linter_1.default('markdownlint', {});
        it('lints markdown source', function () {
            linter.lint('foo.md', "## foo\n- bar\n  - poyo", function (msgs) { return assert.ok(msgs.length > 0); });
            linter.lint('foo.md', "Foo\n===\n", function (msgs) { return assert.ok(msgs.length === 0); });
        });
    });
    describe('mdast-lint', function () {
        var linter = new linter_1.default('mdast-lint', {});
        it('lints markdown source', function () {
            linter.lint('foo.md', "## foo\n- bar\n  - poyo", function (msgs) { return assert.ok(msgs.length > 0); });
            linter.lint('foo.md', "Foo\n===\n", function (msgs) { return assert.ok(msgs.length === 0); });
        });
    });
});
