/// <reference path="lib.d.ts" />
/// <reference path="../../typings/mousetrap/mousetrap.d.ts" />
var Keyboard;
(function (Keyboard) {
    var Receiver = (function () {
        function Receiver(shortcuts) {
            var _this = this;
            this.shortcuts = shortcuts;
            this.callbacks = {};
            var key_handler_for = function (action) { return function () { return _this.dispatch(action); }; };
            for (var key in this.shortcuts) {
                Mousetrap.bind(key, key_handler_for(this.shortcuts[key]));
            }
        }
        Receiver.prototype.on = function (action, callback) {
            this.callbacks[action] = callback;
        };
        Receiver.prototype.dispatch = function (action) {
            if (action in this.callbacks) {
                this.callbacks[action]();
            }
        };
        return Receiver;
    })();
    Keyboard.Receiver = Receiver;
})(Keyboard || (Keyboard = {}));
/// <reference path="../../src/renderer/keyboard.ts" />
context('Keyboard', function () {
    describe('Receiver', function () {
        describe('#constructor', function () {
            it('generates receiver object', function () {
                assert.ok(Keyboard.Receiver);
                assert.ok(new Keyboard.Receiver({}));
            });
        });
    });
});
